---
title: ShadowRoot.innerHTML
slug: Web/API/ShadowRoot/innerHTML
tags:
  - API
  - Property
  - Reference
  - ShadowRoot
  - innerHTML
  - shadow dom
---
<div>{{APIRef("Shadow DOM")}}</div>

<p>The <strong><code>innerHTML</code></strong> property of the {{domxref("ShadowRoot")}} interface sets or returns a reference to the DOM tree inside the <code>ShadowRoot</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>domString</em> = <em>shadowRoot</em>.innerHTML
<em>shadowRoot</em>.innerHTML = <em>domString</em>
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">let customElem = document.querySelector('my-shadow-dom-element');
let shadow = customElem.shadowRoot;

shadow.innerHTML = '&lt;strong&gt;This element should be more important!&lt;/strong&gt;';</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM Parsing', '#dom-innerhtml-innerhtml', 'ShadowRoot.innerHTML')}}</td>
   <td>{{Spec2('DOM Parsing')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ShadowRoot.innerHTML")}}</p>
